#!/usr/bin/perl
 
 #acs::problem_popup("prob. sol"); for later use
 
########################################################################
# COPYRIGHT NOTICE:
#
# Copyright 2008 FocalMedia.Net All Rights Reserved.
#
# Selling the code for this program without prior written consent 
# from FocalMedia.Net is expressly forbidden. You may not 
# redistribute this program in any shape or form.
# 
# This program is distributed "as is" and without warranty of any
# kind, either express or implied. In no event shall the liability 
# of FocalMedia.Net for any damages, losses and/or causes of action 
# exceed the total amount paid by the user for this software.
#
########################################################################

#### EDIT HERE -- FOR WINDOWS/IIS BASED INSTALLATIONS ONLY #######

$config_cgi = "../config.cgi"; ## <-- CHANGE THIS LINE TO THE FULL SERVER PATH TO config.cgi

# THE PATH ON A WINDOWS INSTALLATION WILL LOOK SOMETHING LIKE THIS:
# $config_cgi = "c:/inetpub/webpub/cgi-bin/pseek/config.cgi";

#### DO NOT CHANGE ANYTHING BELOW THIS LINE #################

#use FindBin;
#use lib $FindBin::Bin;
use CGI::Carp qw(fatalsToBrowser); 
use CGI;
use DBI;
use acs;
use obbuild;
use Time::Local; 

&get_setup;
$q = CGI->new;

$default_permissions = 0777; ### PERMISSIONS THAT IS USED FOR TEMPORARY DATA FILES

acs::check_access($username, $password, $q->param('username'), $q->param('password'));

print "Content-type: text/html\n\n";

####################################

if ($q->param('fct') eq "do_import"){&do_import;}
if ($q->param('fct') eq ""){&import_scr;}

#####################################

sub do_import
{

$delimiter = $q->param('delimit');
$cid = $q->param('cid');
$ct = $q->param('ct');

if ($delimiter eq "tab") { $delimiter = "\t"; }
elsif ($delimiter eq "comma") { $delimiter = ","; }
elsif ($delimiter eq "space") { $delimiter = " "; }


if ($q->param('file_to_import') eq "") { acs::problem_popup("You have to specify a file to import."); }

### UPLOAD FILE


		### CHECK IF UPLOAD DIR EXISTS
		$upload_dir = "$data_dir/tmp";
		if ((-e $upload_dir) < 1) {
		mkdir ($upload_dir, $default_permissions);
		chmod($default_permissions,"$upload_dir","$upload_dir"); }
	
		
		### DO UPLOAD
		$upload_filehandle = $q->param('file_to_import');
		open UPLOADFILE, "> $data_dir/tmp/importf.tmp"; 
		binmode UPLOADFILE; 
		  while ( <$upload_filehandle> )
			 {
		    print UPLOADFILE;
			 } 	
		close UPLOADFILE;		


#### 


$normal_fields[0] = "title";
$normal_fields[1] = "description";
$normal_fields[2] = "keywords";
$normal_fields[3] = "url";
$normal_fields[4] = "name";
$normal_fields[5] = "email";
$normal_fields[6] = "rating";
$normal_fields[7] = "votes";
$normal_fields[8] = "hits";
$normal_fields[9] = "premium";
$normal_fields[10] = "newsubm";
$normal_fields[11] = "urldate";
$normal_fields[12] = "subscribed";
$normal_fields[13] = "csuggest";
$normal_fields[14] = "subs_expire";
$normal_fields[15] = "lnkpassword";

$dformat = $q->param('date_format');

$keydata = &get_file_contents("$data_dir/keys.dat");
@akeys = split (/\n/, $keydata);
$knr = @akeys;

$kcount = 0;
foreach $kitem (@akeys)
	{
	($keyname, $visible, $size, $searched, $description, $na, $imgk, $nmbr) = split (/\t/, $kitem);
	$pushval = "$keyname" . "_cust";
	push(@normal_fields, $pushval);
	$kcount++;
	}


	for ($ms = 0; $ms < (16 + $kcount); $ms++)
				{ 
					$paramname = "f" . ($ms + 1);
					if ($q->param($paramname) ne "blank")
						{
						$found_something = "true";
						}
					
					if ($q->param($paramname) eq "title")
						{
						$title_found = "true";
						}
					
				}

if ($found_something ne "true") { acs::problem_popup("Evertying cannot be left blank"); }
if ($title_found ne "true") { acs::problem_popup("Each record that you import should at least have a title present."); }



if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; } 


$impcount = 0;

$nowtime = time();

	open (STP, "$data_dir/tmp/importf.tmp");
		while (defined($line=<STP>))
			{
			chop($line);
			@impfields = split (/$delimiter/, $line);
				
				$import_sql = "";
				
				for ($ms = 0; $ms < (16 + $kcount); $ms++)
				{ 
					$paramname = "f" . ($ms + 1);
					
					### IF THIS IS A DATE
					if (($q->param($paramname) ne "blank") and (($q->param($paramname) eq "urldate") or ($q->param($paramname) eq "premium")))
						{
						
						if ($dformat eq "yyyy/mm/dd"){ ($pyear,$pmonth,$pday) = split(/\//, $impfields[$ms]); }
						if ($dformat eq "mm/dd/yyyy"){ ($pmonth,$pday,$pyear) = split(/\//, $impfields[$ms]); }
						if ($dformat eq "dd/mm/yyyy"){ ($pday,$pmonth,$pyear) = split(/\//, $impfields[$ms]); }
						
							$pmonth = $pmonth - 1;
							
							$@ = "";
							eval {$time = timelocal(0,0,0, $pday,$pmonth,$pyear); };
							
							if ($@ eq "") 
									{
									$time = timelocal(0,0,0, $pday,$pmonth,$pyear); $to_insert_item = $time;
									} 
									else
									{
									if ($q->param($paramname) eq "premium") { $to_insert_item = ""; } else { $to_insert_item = time(); }
									}
						
						$to_insert_item = $dbh->quote($to_insert_item);
						$import_sql = $import_sql . $q->param($paramname) . "=" . "$to_insert_item,";
						
						}
						elsif (($q->param($paramname) ne "blank") and ($impfields[$ms] ne ""))
						{
						$to_insert = $dbh->quote($impfields[$ms]);
						$import_sql = $import_sql . $q->param($paramname) . "=" . "$to_insert,"
						}
					
				}
				
				
				
				$import_sql2 = "INSERT INTO links SET " . $import_sql . "cid = '$cid'";
				
				#print "-> $import_sql2 <BR><BR>";

				$sth = $dbh->prepare($import_sql2);
				if ( !defined $dbh ) {die "Cannot connect to mSQL server: $DBI::errstr - \n\n$import_sql2\n"; }
				$sth->execute;
				$serror = ""; $serror = $sth->errstr; if ($serror ne "") 
						{
						acs::problem_popup("SQL Syntax Error: $serror<BR><BR>From: $import_sql2<BR><BR>");
						exit;
						}
				$impcount++;
			}


if (defined($sth)){ 
$sth->finish; 
}
$dbh->disconnect; 


acs::update_cat_numbers($cid, $impcount);


$hbox = acs::get_heading_box("$web_url/ic_misc.gif", "$impcount Listings Imported", qq[
<p><a href="$admin_url/admin38.cgi?ct=$ct&cid=$cid">Click here to import more listings</a> or 
<a href="javascript:onClick=window.close()">click here to close this window.</p></a>]);


print qq[<html>
<head>
<title>Import</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css">
</head>
<body onUnload="opener.location.reload(true);">

$hbox

</body>
</html>
];



}






sub import_scr
{
# hidden values form prev area...(dir man)
$cid = $q->param('cid'); 
$ct = $q->param('ct');
$category = acs::get_location_string($ct);


$hbox = acs::get_heading_box("$web_url/ic_misc.gif", "Import Listings", qq[
<p>Import listings into: <strong>$category</strong></p>

<p><strong>Other Import/Export Tools</strong>

<ul>
  <li><a href="$admin_url/p_import.cgi?fct=import">Import Links with Categories (Import/Export
    Utility)</a></li>
  <li><a href="$admin_url/p_import.cgi?fct=export">Export Links (Import/Export Utillity)</a></li>
</ul>]);




### FIELDS TO IMPORT
@normal_fields = ("blank:Blank",
						"title:Link Title",
						"description:Link Description",
						"keywords:Link Keywords",
						"url:Link URL",
						"name:Contact Name",
						"email:Contact Email",
						"rating:Rating",
						"votes:Votes",
						"hits:Hits",
						"premium:Premium Link or Not (Y/N)",
						"newsubm:New Submission or Not (Y/N)",
						"urldate:Date of Listing",
						"subscribed:Subscribed",
						"csuggest:Category Suggested (Submission Time)",
						"subs_expire:Premium Link Expiry Date",
						"lnkpassword:Link Password"
						);



### GET EXTRA KEYS/FIELDS 

$keydata = &get_file_contents("$data_dir/keys.dat");
@akeys = split (/\n/, $keydata);
$knr = @akeys;


$kcount = 0;
foreach $kitem (@akeys)
	{
	($keyname, $visible, $size, $searched, $description, $na, $imgk, $nmbr) = split (/\t/, $kitem);
	
	$pushval = "$keyname" . "_cust:" . $description  . " (Extra Field)";
	push(@normal_fields, $pushval);
	$kcount++;

	} 



### WORK OUT SELECTION BOXES


for ($ms = 1; $ms < (17 + $kcount); $ms++)
	{ 
	$fnumber = $ms;
	$fieldname = "f" . "$ms";

	$sel_count = 0; $normal_fields = "";
	foreach $f_item(@normal_fields)
		{
		($fielf_value, $field_diz) = split (/:/, $f_item);
		 if ($sel_count == $ms) { $selected_val = "selected"; } else { $selected_val = ""; }
		 $normal_fields = $normal_fields . qq[<option value="$fielf_value" $selected_val>$field_diz</option>];
		 $sel_count++;
		}
	
$selboxes_with_table = $selboxes_with_table . qq[
<tr>
<td width="20%" valign="top" bgcolor="#FFFFFF" class="normaltext">Field $fnumber: </td>
<td width="80%" valign="top" bgcolor="#FFFFFF">
<select name="$fieldname" size="1">
$normal_fields
$koptions
</select></td>
</tr>
	];
	
	}







 

print qq[<html>
<head>
<title>Import</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css" />  
</head>
<body>

$hbox

<table width="100%" cellpadding="6" cellspacing="1" bgcolor="#FFFFFF" style="border: 1px solid rgb(219,219,219)">
  <tr>
    <td width="100%" height="30" background="$web_url/bar6.gif"><strong class="normaltext">Import
    Rules:</strong></td>
  </tr>
  <tr>
    <td width="100%" height="30"><ul>
      <li>
        <p>The text file has to be <b>tab</b>, <b>comma</b> or <b>space</b> delimited. In other words fields need to be seperated by <b>tab characters, space or comma characters.</b></p>
      </li>
      <li>
        <p>Each record must end with a <strong>carriage return.</strong></p>
      </li>
      <li>
        <p>Each record should at least have a <strong>title </strong>present.</p>
      </li>
      <li>
      <p>Select the format of the text file you would like to import by choosing the field type (title, description, etc.) order from the drop down boxes below.</p>
      </li>
      <li>
      <p>Choose 'Blank' from the drop down menu's below if there are more fields available that you actually have in the import file.</p>
      </li>
      
    </ul>
    </td>
  </tr>
</table>

<table border="0" cellpadding="0" cellspacing="0" width="100%" background="$web_url/shadow.gif">
  <tr><td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font></td><td width="99%"></td></tr>
</table>



<form method="POST" action="$admin_url/admin38.cgi" ENCTYPE="multipart/form-data">
<input type="hidden" name="fct" value="do_import">
<input type="hidden" name="cid" value="$cid">
<input type="hidden" name="ct" value="$ct">

<table width="100%" cellpadding="6" cellspacing="1" bgcolor="#FFFFFF" style="border: 1px solid rgb(219,219,219)">

  <tr>
    <td width="100%" height="30" class="normaltext" colspan="2" style="border-bottom: 1px solid rgb(225,225,225)" background="$web_url/bar6.gif">
    <b>Import File Format: (Choose fields below)</b>
    </td>
  </tr>

  <tr>
    <td width="20%" height="30" background="$web_url/bar6.gif" class="normaltext" style="border-bottom: 1px solid rgb(225,225,225)" ><strong>Field</strong></td>
    <td width="80%" background="$web_url/bar6.gif" class="normaltext" style="border-bottom: 1px solid rgb(225,225,225)" ><strong>Value</strong></td>
  </tr>


  
$selboxes_with_table
  <tr>
      <td width="20%" height="30" class="normaltext"><strong></strong>Import
      File:<strong></strong></td>
      <td width="80%" class="normaltext">
      <input type="file" name="file_to_import" size="50">
      </td>
  </tr>

  <tr>
    <td height="30" class="normaltext"><strong>Date Format: </strong></td>
    <td class="normaltext"><select size="1" name="date_format">
        <option value="yyyy/mm/dd"> yyyy/mm/dd </option>
        <option value="mm/dd/yyyy"> mm/dd/yyyy </option>
        <option value="dd/mm/yyyy"> dd/mm/yyyy </option>
      </select> 
      If you are importing dates specify in what format they are. (For the date of the listing and/or 'premium expiry date') </td>
  </tr>
  <tr>
    <td width="20%" height="30" class="normaltext"><strong>Delimitation:</strong></td>
    <td width="80%" class="normaltext"><select name="delimit" size="1">
      <option value="tab">tab</option>
      <option value="comma">comma</option>
      <option value="space">space</option>
    </select> This is the character by which fields are seperated by.</td>
  </tr>
  <tr>
    <td width="20%" height="30" class="normaltext"></td>
    <td width="80%" class="normaltext"><strong><input type="submit" value="Import" name="B2"></strong>
    <br>
    <br>
    Note that listings will be imported into:<br>
    <strong>$category</strong> </td>
  </tr>
</table>


<table border="0" cellpadding="0" cellspacing="0" width="100%" background="$web_url/shadow.gif">
  <tr><td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font></td><td width="99%"></td></tr>
</table>
</form>



</body>
</html>

];


}


##################################################################################


####################################################################################


sub get_setup
{

$exists = (-e "$config_cgi");
if ($exists > 0)
	{
	open (STP, "$config_cgi");
		while (defined($line=<STP>))
			{
			if ($line =~ m/#/g)
				{
				$r = pos($line);
				$line = substr($line, 0, $r - 1);
				}
				
				$line =~ s/\n//g;
	
if ($line =~ /^DB_NAME/){$db_name = &get_setup_line($line, DB_NAME);}
if ($line =~ /^DB_USERNAME/){$db_username = &get_setup_line($line, DB_USERNAME);}
if ($line =~ /^DB_PASSWORD/){$db_password = &get_setup_line($line, DB_PASSWORD);}
if ($line =~ /^MYSQL_HOSTNAME/){$mysql_hostname = &get_setup_line($line, MYSQL_HOSTNAME);}
if ($line =~ /^MYSQL_PORT/){$mysql_port = &get_setup_line($line, MYSQL_PORT);}

if ($line =~ /^SCRIPT_URL/){$script_url = &get_setup_line($line, SCRIPT_URL);}
if ($line =~ /^ADMIN_URL/){$admin_url = &get_setup_line($line, ADMIN_URL);}
if ($line =~ /^WEB_URL/){$web_url = &get_setup_line($line, WEB_URL);}
if ($line =~ /^WEB_DIR/){$web_dir = &get_setup_line($line, WEB_DIR);}
if ($line =~ /^DATA_DIR/){$data_dir = &get_setup_line($line, DATA_DIR);}

if ($line =~ /^USERNAME/){$username = &get_setup_line($line, USERNAME);}
if ($line =~ /^PASSWORD/){$password = &get_setup_line($line, PASSWORD);}


			}
	close (STP);
	
	}
}




sub get_setup_line
{
my ($setup_line, $setup_var) = @_;
$crit = "\"";
$setup_line =~ m/$crit/g;
$r1 = pos($setup_line);
$setup_line =~ m/$crit/g;
$r2 = pos($setup_line);
$setup_line = substr($setup_line, $r1, ($r2 - $r1 - 1));
$return_val = $setup_line;
return ($return_val);
}

#### END CONFIGURATION ########################################################

